﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.WinForms.DataGrid;

namespace v2_get_value_by_row_column
{
    // https://www.syncfusion.com/kb/9774/how-to-change-the-enter-key-behavior-in-winforms-datagrid-sfdatagrid
    // Change Enter key to be same as tab key...
    public class CustomSelectionController : Syncfusion.WinForms.DataGrid.Interactivity.RowSelectionController
    {
        SfDataGrid DataGrid;

        public CustomSelectionController(SfDataGrid sfDataGrid)
            : base(sfDataGrid)
        {
            this.DataGrid = sfDataGrid;
        }

        protected override void HandleKeyOperations(KeyEventArgs args)
        {
            if (args.KeyCode == Keys.Enter)
            {
                KeyEventArgs arguments = new KeyEventArgs(Keys.Tab);
                base.HandleKeyOperations(arguments);
                return;
            }

            base.HandleKeyOperations(args);
        }
    }
}
