﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using Syncfusion.WinForms.DataGrid;
using Syncfusion.Data;
using Syncfusion.WinForms.DataGrid.Events;
using Syncfusion.WinForms.DataGrid.Interactivity;

namespace v2_get_value_by_row_column
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
            this.sfDataGrid1.SelectionController = new CustomSelectionController(sfDataGrid1);
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            DataTable dt = new DataTable();

            dt.Columns.Add("T1", typeof(string));
            dt.Columns.Add("D2", typeof(double));
           
            dt.Rows.Add("t1 - one", 2.1);
            dt.Rows.Add("t1 - two", 2.2);
            dt.Rows.Add("t1 - three", 2.3);

            sfDataGrid1.DataSource = dt;
            sfDataGrid1.Columns["D2"].ShowToolTip = true;
            sfDataGrid1.ToolTipOpening += SfDataGrid1_ToolTipOpening1;
            sfDataGrid1.AllowFiltering = true;

            sfDataGrid1.AddNewRowPosition = Syncfusion.WinForms.DataGrid.Enums.RowPosition.FixedBottom;
            sfDataGrid1.SelectionController = new RowSelectionControllerExt(sfDataGrid1);
        }

        private void SfDataGrid1_ToolTipOpening1(object sender, ToolTipOpeningEventArgs e)
        {
            if (e.Column.MappingName == "D2")
            {
                int row = e.RowIndex;
                int col = e.ColumnIndex;

                // Works..
                SfDataGrid sfdg = (SfDataGrid)e.OriginalSender;

                //var targetRecord = sfdg.View.Records[row];

                e.ToolTipInfo.Items[0].Text = "Testing :: row " + row + " col " + col + " " + e.DisplayText + " " + sfdg.Name + "::";
                
                //e.ToolTipInfo.Items[0].Text = "Testing :: row " + row + " col " + col + " " + e.DisplayText + " ";


            }
        }

        private void button_get_value_Click(object sender, EventArgs e)
        {
            // to get the record of specific row index. 
            var rowIndex = int.Parse(integerTextBox_row.Text);
            var colIndex = int.Parse(integerTextBox_col.Text);
            var rowData = sfDataGrid1.GetRecordAtRowIndex(rowIndex);
            var column = sfDataGrid1.Columns[colIndex];
            var propertyCollection = this.sfDataGrid1.View.GetPropertyAccessProvider();

            //to get the cellvalue of specific row and column  
            var cellValue = propertyCollection.GetValue(rowData, column.MappingName);
            MessageBox.Show("Row,Col " + rowIndex + " ,"  + colIndex + " Value ::" + cellValue.ToString() + "::");

            //Get DataRow            
            var dataRowView = sfDataGrid1.GetRecordAtRowIndex(rowIndex);
            var dr = (dataRowView as DataRowView).Row;
            string msg2 = string.Empty;
            DataTable dt = (DataTable)sfDataGrid1.DataSource;

            foreach (DataColumn dc in dt.Columns)
            {
                msg2 += " Column ::" + dc.ColumnName + ":: Type ::" + dc.DataType.ToString() + ":: Value ::" + dr[dc.ColumnName] + "::" + Environment.NewLine;
            }

            MessageBox.Show(msg2);

        }

        private void button_filter_flip_Click(object sender, EventArgs e)
        {
            if (sfDataGrid1.Columns["D2"].FilterPredicates.Count == 0)
            {
                sfDataGrid1.Columns["D2"].FilterPredicates.Add(new FilterPredicate() { FilterType = FilterType.Equals, FilterValue = 10 });
            }
            else
            {
                sfDataGrid1.Columns["D2"].FilterPredicates.Clear();
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (sfDataGrid1.Columns["T1"].FilterPredicates.Count == 0)
            {
                sfDataGrid1.Columns["T1"].FilterPredicates.Add(new FilterPredicate() { FilterType = FilterType.Equals, FilterValue = "BOB" , IsCaseSensitive = true});
            }
            else
            {
                sfDataGrid1.Columns["T1"].FilterPredicates.Clear();
            }
        }

#if false
        // Syncfusion DOES not support this type of filtering if attached to DataTable! Must do it with column filtering and predicates
        public bool FilterRecords(object o)
        {
            //string filterText = "FRANS";
            string trab = o.ToString();
            MessageBox.Show("oBJECT O type ::" + o.GetType().ToString() + ":: value ::" + o.ToString() + "::");
            if (trab.Length > 3)
                return true;
            else
                return false;
        }

        private void btnApplyFilter_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Here I am ");
            sfDataGrid1.View.Filter = FilterRecords;
            sfDataGrid1.View.RefreshFilter();
        }
#endif
        private void sfDataGrid1_CurrentCellValidating(object sender, CurrentCellValidatingEventArgs e)
        {
            SfDataGrid sfdg = (SfDataGrid)sender;
            if (e.Column.MappingName == "T1")
            {
                if (e.NewValue.ToString() == "BART")
                {
                    e.IsValid = false;
                    MessageBox.Show("fOUND A BART");
                }
            }
        }

        //RowSelectionControllerExt _rs;
        private void sfButton1_Click(object sender, EventArgs e)
        {

            if (sfDataGrid1.SelectionUnit == Syncfusion.WinForms.DataGrid.Enums.SelectionUnit.Cell)
            {
                MessageBox.Show("Selection Unit is Cell");
            }
            else if (sfDataGrid1.SelectionUnit == Syncfusion.WinForms.DataGrid.Enums.SelectionUnit.Row)
            {
                MessageBox.Show("Selection Unit is Row and setting row controler extension for continuos new row")
                    ;

                sfDataGrid1.SelectionController = new RowSelectionControllerExt(sfDataGrid1);


            }
            else if (sfDataGrid1.SelectionUnit == Syncfusion.WinForms.DataGrid.Enums.SelectionUnit.Any)
            {
                MessageBox.Show("Selectoin Unit is Any");
            } else
            {
                MessageBox.Show("Undefined Selection Unti");
            }
        }
    }
}
